/*
*/

#ifndef __H_DEFS__
#define __H_DEFS__

#include <limits.h>

/** @file
 * 
 */

#ifdef __cplusplus
#define BEGIN_DECLS extern "C" {
#else
#define BEGIN_DECLS
#endif /*__cplusplus*/


#ifdef __cplusplus
#define END_DECLS }
#else
#define END_DECLS
#endif /* __cplusplus */

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE !FALSE
#endif

typedef long hash_t;

typedef void* spointer;

typedef enum {
  S_TYPES_NONE = 0,
  S_TYPES_INT,
  S_TYPES_CHAR,
  S_TYPES_SHORT,
  S_TYPES_BOOLEAN,
  S_TYPES_LONG,
  S_TYPES_UINT,
  
  
  S_TYPES_OBJECT = INT_MAX - 1,
  S_TYPES_INVALID = INT_MAX
} S_TYPES;

#endif
